import os,pickle,random
import pygame
from pygame.locals import *
import tinos, tinspr, city
#--------------------------------------------------------------


def tincity_train_cost(nud):
	allow = ["vertical_walkway_with_rail",\
		"horizontal_walkway_with_rail",\
		"horizontal_rail_with_road",\
		"vertical_rail_with_road",\
		"vertical_water_with_rail",\
		"horizontal_water_with_rail"	]
	if nud.typ == "rail" or nud.name in allow:
		return 1
	return None

class tincity_titrain(object):
	def __init__(self,parent):
		self.game = parent
		self.city = parent.city
		self.matrix = parent.city.matrix
		self.spr = parent.spr
		self.train_image = ["grey_","red_","yellow_","green_","blue_"]
		self.erlod = True
		self.wagon = []
		self.last_train_image = "train_horizontal"

	def update(self):
		if len(self.city.sum["rail"]) > 9:
			if self.erlod == True:
				self.erlod = False
				self.src = random.choice(self.city.sum["rail"])
				self.path = []
			if len(self.path) == 0:
				self.dest = self.src
				self.path = None
				while (self.path == None) or (len(self.path) <= 6):
					self.src = random.choice(self.city.sum["rail"])
					self.path = self.matrix.findpath(self.src,self.dest,tincity_train_cost)
					#print self.path
			self.wagon.append(self.path.pop(0))
			if len(self.wagon) > 5:
				self.wagon.pop(0)		
			for (x,y) in self.wagon:
				#train_image = "train_horizontal"
				if self.matrix.at(x,y).name == "downright_rail" or self.matrix.at(x,y).name == "upleft_rail":
					self.last_train_image = "train_dediagonal"
				elif self.matrix.at(x,y).name == "downleft_rail" or self.matrix.at(x,y).name == "upright_rail":
					self.last_train_image = "train_diagonal"
				elif self.matrix.at(x,y).name == "horizontal_rail":
					self.last_train_image = "train_horizontal"
				elif self.matrix.at(x,y).name == "vertical_rail":
					self.last_train_image = "train_vertical"
				self.spr.blit_to(self.game.image,(x*5,y*5),self.train_image[0] + self.last_train_image)
				self.train_image.append(self.train_image.pop(0))

#================================================================================

class tincity_new(object):
	def __init__(self,parent):
		self.game = parent
		self.image = pygame.Surface((128,128))
		self.fnt = parent.fnt
		self.keyb = parent.keyb
		self.bg = pygame.Surface((128,128))
		self.bg.fill((208,208,208))
		pygame.draw.rect(self.bg, (255,255,255), (1,1,118,7))
		self.fnt.write(self.bg,(55,2),"new")
		pygame.draw.rect(self.bg, (255,255,255), (120,1,7,7))
		self.fnt.write(self.bg,(121,2),"X")
		self.fnt.write(self.bg,(2,9)," use the keyboard\n to enter the name\n of the new city\n then press enter")
		pygame.draw.rect(self.bg, (255,255,255), (1,88,126,7))
	
	def build(self):
		self.game.screen = "new"

	def update(self):
		self.image.blit(self.bg,(0,0))
		self.keyb.update()
		self.image.blit(self.keyb.image,(0,96))
		self.fnt.write(self.image,(2,89),self.keyb.sheet)
		if self.keyb.last_key == "RET":
			name = self.keyb.sheet[:len(self.keyb.sheet)-1]
			self.game.city = city.city(name)
			self.game.screen = "play"
			self.game.mode = "click"
			self.game.titrain = tincity_titrain(self.game)
			self.keyb.reset()
	
	def click(self,x,y):
		if (x>120) and (y < 8):
			self.game.screen = "play"
			self.game.mode = "click"
		elif (y>96):
			self.keyb.click((x,y-96))
	
	def stroke(self,key):
		self.keyb.key_down(key)

#----------------------------------------------------------------
class tincity_load(object):
	def __init__(self,parent):
		self.game = parent
		self.image = pygame.Surface((128,128))
		self.fnt = parent.fnt
		self.bg = pygame.Surface((128,128))
		self.bg.fill((0,0,192))
		pygame.draw.rect(self.bg, (255,255,255), (1,1,118,7))
		self.fnt.write(self.bg,(52,2),"load")
		pygame.draw.rect(self.bg, (255,255,255), (120,1,7,7))
		self.fnt.write(self.bg,(121,2),"X")
		pygame.draw.rect(self.bg, (255,255,255), (1,9,126,109))
		pygame.draw.rect(self.bg, (255,255,255), (1,120,25,7))
		pygame.draw.rect(self.bg, (0,0,0), (28,120,50,7))
		self.fnt.write(self.bg,(2,121),"load")
		self.mode = None
		self.all_file = []
	
	def build(self):
		self.game.screen = "load"

	def update(self):
		if not self.mode:
			self.mode = True
			for file in os.listdir(os.getcwd()):
				if (file[len(file)-4:] == ".pkl") and file != "title.pkl":
					self.all_file.append(file)
		self.image.blit(self.bg,(0,0))
		tmp_y = 10
		for file in self.all_file:
			if tmp_y < 116:
				self.fnt.write(self.image,(2,tmp_y),file)
				tmp_y += 6
		if type(self.mode) == int:
			if self.mode < 18:
				pygame.draw.rect(self.image,(0,0,255),(1,(self.mode*6)+9,126,7),1)
	
	def click(self,x,y):
		if (x>120) and (y < 8):
			self.game.screen = "play"
			self.game.mode = "click"
			self.mode = None
			self.all_file = []
		elif (y>8) and (y<120):
			self.mode = (y-8)/6
		elif (y>120) and (x<26) and (type(self.mode)==int) and (self.mode < 18):
			if self.mode <= len(self.all_file)-1:
				self.game.city = pickle.load(open(self.all_file[self.mode],"r"))
				self.game.screen = "play"
				self.game.mode = "click"
				self.mode = None
				self.all_file = []
				self.game.titrain = tincity_titrain(self.game)
	
	def stroke(self,key):
		pass

#------------------------------------------------------------------------
class tincity_save(object):
	def __init__(self,parent):
		self.game = parent
		self.image = pygame.Surface((128,128))
		self.fnt = parent.fnt
		self.bg = pygame.Surface((128,128))
		self.bg.fill((0,192,0))
		pygame.draw.rect(self.bg, (255,255,255), (1,1,118,7))
		self.fnt.write(self.bg,(52,2),"save")
		pygame.draw.rect(self.bg, (255,255,255), (120,1,7,7))
		self.fnt.write(self.bg,(121,2),"X")
		pygame.draw.rect(self.bg, (255,255,255), (42,119,43,7))
		pygame.draw.rect(self.bg, (96,96,255), (41,118,45,9),1)
		self.fnt.write(self.bg,(43,120),"confirm")
	
	def build(self):
		self.game.screen = "save"
	
	def update(self):
		self.image.blit(self.bg,(0,0))
		self.fnt.write(self.image,(43,54),"save as")
		self.fnt.write(self.image,((128-((len(self.game.city.name)+3))*6)/2,60),self.game.city.name+".pkl")
	
	def click(self,x,y):
		if (x>120) and (y < 8):
			self.game.screen = "play"
			self.game.mode = "click"
		elif (x > 40) and (y>118) and (x < 85) and (y<127):
			pickle.dump(self.game.city,open(self.game.city.name+".pkl","w"))
			self.game.screen = "play"
			self.game.mode = "click"
	
	def stroke(self,key):
		pass
#------------------------------------------------------------------------

class tincity_info(object):
	def __init__(self,parent):
		self.tile = None
		self.game = parent
		self.image = pygame.Surface((128,128))
		self.fnt = parent.fnt
		self.bg = pygame.Surface((128,128))
		self.bg.fill((0,192,0))
		pygame.draw.rect(self.bg, (255,255,255), (120,1,7,7))
		self.fnt.write(self.bg,(121,2),"X")
		pygame.draw.rect(self.bg, (0,0,0), (5,60,80,7))
		pygame.draw.rect(self.bg, (255,255,255), (4,59,80,7))
		self.fnt.write(self.bg,(5,60),"crime : ")
		pygame.draw.rect(self.bg, (0,0,0), (5,70,80,7))
		pygame.draw.rect(self.bg, (255,255,255), (4,69,80,7))
		self.fnt.write(self.bg,(5,70),"polution : ")
		pygame.draw.rect(self.bg, (0,0,0), (5,80,80,7))
		pygame.draw.rect(self.bg, (255,255,255), (4,79,80,7))
		self.fnt.write(self.bg,(5,80),"value : ")
		pygame.draw.rect(self.bg, (0,0,0), (5,90,80,7))
		pygame.draw.rect(self.bg, (255,255,255), (4,89,80,7))
		self.fnt.write(self.bg,(5,90),"density : ")
		pygame.draw.rect(self.bg, (0,0,0), (5,100,80,7))
		pygame.draw.rect(self.bg, (255,255,255), (4,99,80,7))
		self.fnt.write(self.bg,(5,100),"trafic : ")
		pygame.draw.rect(self.bg, (0,0,0), (5,110,80,7))
		pygame.draw.rect(self.bg, (255,255,255), (4,109,80,7))
		pygame.draw.rect(self.bg, (0,0,0), (10,10,9,9))
		pygame.draw.rect(self.bg, (255,128,255), (8,8,9,9))
		pygame.draw.rect(self.bg, (0,0,0), (24,10,80,9))
		pygame.draw.rect(self.bg, (255,255,255), (22,8,78,9))
	
	def build(self):
		self.game.mode = "info"
	
	def update(self):
		self.image.blit(self.bg,(0,0))
		self.game.spr.blit_to(self.image,(10,10),self.tile.name)
		self.fnt.write(self.image,(25,11),self.tile.typ)
		self.fnt.write(self.image,(53,60),str(self.tile.stats["crime"]))
		self.fnt.write(self.image,(71,70),str(self.tile.stats["polution"]))
		if "value" in self.tile.stats:
			self.fnt.write(self.image,(53,80),str(self.tile.stats["value"]))
		if "density" in self.tile.stats:
			self.fnt.write(self.image,(65,90),str(self.tile.stats["density"]))
		if "trafic" in self.tile.stats:
			self.fnt.write(self.image,(58,100),str(self.tile.stats["trafic"]))
	
	def click(self,x,y):
		if (x>120) and (y < 8):
			self.game.screen = "play"
			self.game.mode = "info"
	
	def stroke(self,key):
		pass

#------------------------------------------------------------------------
class tincity_build(object):
	def __init__(self,parent):
		self.game = parent
		self.image = pygame.Surface((128,128))
		self.fnt = parent.fnt
		self.spr = parent.spr
		self.bg = pygame.Surface((128,128))
		self.bg.fill((0,192,0))
		#exit
		pygame.draw.rect(self.bg, (255,255,255), (120,1,7,7))
		self.fnt.write(self.bg,(121,2),"X")
		#title
		pygame.draw.rect(self.bg, (255,255,255), (1,1,117,7))
		self.fnt.write(self.bg,(28,2),"Construction")
		#icons
		self.icon = {
			"construction":(pygame.Rect(59,10,68,7), (128,255,255), "bulldoze 2$"),\
			"residential":(pygame.Rect(1,34,126,7), (255,128,128), "residential    100$"),\
			"commercial":(pygame.Rect(1,42,126,7), (128,128,255), "commercial     100$"),\
			"industrial":(pygame.Rect(1,50,126,7), (255,255,128), "industrial     100$"),\
			"road":(pygame.Rect(1,18,56,7), (255,128,255), "road 10$"),\
			"rail":(pygame.Rect(1,26,56,7), (255,128,255), "rail 20$"),\
			"walk":(pygame.Rect(1,10,56,7), (255,128,255), "walk 5$"),\
			"tree":(pygame.Rect(59,18,68,7), (128,255,255), "tree 5$"),\
			"water":(pygame.Rect(59,26,68,7), (128,255,255), "water 10$")\
		}
		for ikecon in self.icon:
			icon = self.icon[ikecon]
			pygame.draw.rect(self.bg, icon[1], icon[0])
			self.spr.blit_to(self.bg, (icon[0].x+1,icon[0].y+1), ikecon)
			self.fnt.write(self.bg, (icon[0].x+7,icon[0].y+1), icon[2])
		#confirm button
		pygame.draw.rect(self.bg, (255,255,255), (0,115,20,13))
		pygame.draw.rect(self.bg, (0,0,0), (1,116,18,11),1)
		self.fnt.write(self.bg, (4,119), "Ok")
	
	def build(self):
		self.game.screen = "construction"
	
	def update(self):
		self.image.blit(self.bg,(0,0))
		if self.game.mode in self.icon:
			pygame.draw.rect(self.image, (0,0,255), self.icon[self.game.mode][0], 1)
	
	def click(self,x,y):
		if (x>120) and (y < 8):
			self.game.screen = "play"
			self.game.mode = "click"
		elif (x<20) and (y>115):
			self.game.screen = "play"
		else:
			for icon_mode in self.icon:
				if self.icon[icon_mode][0].collidepoint(x,y):
					self.game.mode = icon_mode
					#self.game.screen = "play"
	
	def stroke(self,key):
		pass

#------------------------------------------------------------------------

class tincity_proceed(object):
	def __init__(self,parent):
		self.parent = parent
		#self.proceed = False
	
	def build(self):
		if self.parent.proceed:
			self.parent.proceed = False
			self.parent.options["proceed"] = ("pause",pygame.Rect(121,21,5,5),self)
		else:
			self.parent.proceed = True
			self.parent.options["proceed"] = ("proceed",pygame.Rect(121,21,5,5),self)
		self.parent.screen = "play"
		self.parent.mode = "click"
		#self.parent.city.proceed()

class tincity_game(object):
	def __init__(self):
		self.image = pygame.Surface((128,128))
		self.screen = "play"
		self.mode = "click"
		self.proceed = False
		self.simulslow = 6
		self.simulwait = 0
		self.city = pickle.load(open("title.pkl","r"))
		#self.city = city.city("title")
		self.fnt ,self.keyb = tinos.tinfnt(), tinos.tiny_keyboard()
		self.spr = tinspr.tinspr("tincity")
		self.options = {
		"new":("new",pygame.Rect(121,101,5,5),tincity_new(self)),\
		"load":("load",pygame.Rect(121,107,5,5),tincity_load(self)),\
		"save":("save",pygame.Rect(121,113,5,5),tincity_save(self)),\
		"info":("info",pygame.Rect(121,8,5,5),tincity_info(self)),\
		"play":("none",pygame.Rect(0,0,0,0),self),\
		"construction":("construction",pygame.Rect(121,15,5,5),tincity_build(self)),\
		"click":("click",pygame.Rect(121,2,5,5),self),\
		"proceed":("proceed",pygame.Rect(121,21,5,5),tincity_proceed(self))\
		}
		#===========predraw play bg
		self.bg = pygame.Surface((128,128))
		pygame.draw.rect(self.bg, (255,204,153), (1,1,118,118))
		pygame.draw.rect(self.bg, (255,153,102), (120,120,7,7))
		pygame.draw.rect(self.bg, (204,153,102), (120,1,7,68))
		pygame.draw.rect(self.bg, (192,192,192), (1,120,37,7))
		pygame.draw.rect(self.bg, (255,64,255), (39,120,35,7))
		pygame.draw.rect(self.bg, (127,127,127), (75,120,44,7))
		pygame.draw.rect(self.bg, (0,127,255), (120,100,7,19))	#new load save
		#for ikecon in self.options.keys():
		#	self.spr.blit_to(self.bg,self.options[ikecon][1],self.options[ikecon][0])
		self.titrain = tincity_titrain(self)
	
	def build(self):
		self.mode = "click"
	
	def update(self):
		if self.proceed:
			self.simulwait += 1
			if self.simulwait >= self.simulslow: 
				self.city.proceed()
				self.simulwait = 0
		#will render and process the game screen
		if self.screen == "play":
			self.image.blit(self.bg,(0,0))
			for ikecon in self.options.keys():
				self.spr.blit_to(self.image,self.options[ikecon][1],self.options[ikecon][0])
			#========the game map itself !!!!!
			for (x,y) in self.city.matrix.all():
				self.city.matrix.at(x,y).update()
				self.spr.blit_to(self.image,(x*5,y*5),self.city.matrix.at(x,y).name)
			#========the bottom right icon that show what u currently selected!!!
			if self.mode in self.spr.rect:
				self.spr.blit_to(self.image,(121,121),self.mode)
			if self.mode in self.options:
				pygame.draw.rect(self.image,(0,0,255),self.options[self.mode][1].inflate(2,2),1)
			#========current fund
			self.fnt.write(self.image,(2,121),str(self.city.cash)+"$")
			#=========current population
			self.fnt.write(self.image,(40,121),str(int(self.city.stats["population"])))
			self.spr.blit_to(self.image,(69,121,5,5),"population")
			#======= +C+I==RCI
			R = ((self.city.stats["R"] *5)+1)%6
			C = ((self.city.stats["C"] *5)+1)%6
			I = ((self.city.stats["I"] *5)+1)%6
			if R:
				pygame.draw.rect(self.image, (255,0,0), (80,127-R,9,R))
			if C:
				pygame.draw.rect(self.image, (0,0,255), (92,127-C,9,C))
			if I:
				pygame.draw.rect(self.image, (255,255,0), (104,127-I,9,I))
			self.fnt.write(self.image,(76,121)," R C I ")
			self.titrain.update()
		else:
			self.options[self.screen][2].update()
			self.image.blit(self.options[self.screen][2].image,(0,0))

	
	def click(self,x,y):
		if self.screen == "play":
			if (x<120) and (y<120):
				x,y = x/5,y/5
				if self.mode == "info":
					self.options["info"][2].tile = self.city.matrix.at(x,y)
					self.screen = "info"
				elif self.city.matrix.at(x,y).typ == "grass":
					if self.mode in self.city.action:
						self.city.build(x,y,self.mode)
				elif self.mode == "construction":
					self.city.build(x,y,"construction")
			#==========else if you click inside the options tab on the right
			elif (x>120) and (y<120):
				for option_mode in self.options.keys():
					if self.options[option_mode][1].collidepoint(x,y):
						self.options[option_mode][2].build()
		else:
			self.options[self.screen][2].click(x,y)
	
	def stroke(self,key):
		if self.screen == "new":
			self.options["new"][2].stroke(key)

#-------------------------------------------------

#-------------------------------------------------
if __name__ == "__main__":
	end = False
	pygame.init()
	pygame.display.set_caption("TinCity")
	pygame.mouse.set_visible(1)
	pygame.event.set_allowed(None)
	pygame.event.set_allowed([QUIT,KEYDOWN,MOUSEBUTTONDOWN,USEREVENT])
	window = pygame.display.set_mode((128, 128))
	timer = pygame.time.Clock()
	mbutton = False
	#-------------------------------------------------------------------
	game = tincity_game()
	#-------------------------------------------------------------------
	while end == False :
		#=====================================================
		game.update()
		#======================================================
		window.blit(game.image,(0,0))
		pygame.display.flip()
		timer.tick(10)
		event = pygame.event.poll()
		if event.type == QUIT:
			end = True
		elif event.type == MOUSEBUTTONDOWN:
			x,y = event.pos
			game.click(x,y)
		elif event.type == KEYDOWN:
			game.stroke(pygame.key.name(event.key))
		#======================================================